#include <3ds/types.h>
#include <3ds/svc.h>
#include <3ds/os.h>

u32 osConvertVirtToPhys(u32 vaddr)
{
    if(vaddr >= 0x14000000 && vaddr < 0x1c000000)
        return vaddr + 0x0c000000; // LINEAR heap
    if(vaddr >= 0x30000000 && vaddr < 0x40000000)
        return vaddr - 0x10000000; // Only available under FIRM v8+ for certain processes.
    if(vaddr >= 0x1F000000 && vaddr < 0x1F600000)
        return vaddr - 0x07000000; // VRAM
    return 0;
}
